function v = v_cycle(v,f);

nu1 = 5;
nu2 = 5;

omega = 0.8;

N = length(v);
h = 1/(N+1);

[A,L,R,D] = prepare_matrices(h,N);
[I_fine_to_rough, I_rough_to_fine] = find_intermesh(N);

disp(N)
if N>1
    % if N=1, the roughest mesh has been reached
    
    for ctr=1:nu1
       v = (D+omega*L)\(omega*f + ((1-omega)*D - omega*R)*v); 
    end
    
    f2h = I_fine_to_rough*(f - A*v);
    
    v2h = v_cycle(zeros((N-1)/2,1),f2h);
    
    v = v + I_rough_to_fine*(v2h);
        
end
    

for ctr=1:nu2
    v = (D+omega*L)\(omega*f + ((1-omega)*D - omega*R)*v);  
end
    
    