function [I_fine_to_rough, I_rough_to_fine] = find_intermesh(N)

I = [1:2:N-2];
J = [1:(N-1)/2];
S = ones(size(I));

n = (N-1)/2;
disp(['finding intermesh from ',num2str(N),' to ',num2str(n)]);

I_rough_to_fine = 0.5*(sparse(I,J,S,N,n) + 2*sparse(I+1,J,S,N,n) + sparse(I+2,J,S,N,n));

I_fine_to_rough = sparse(J,I+1,S,n,N);